//+------------------------------------------------------------------+
//|                                                 SOS_Channels.mq4 |
//|                                     Copyright  2006, soso_beton |
//|                                            http://www.fxlogs.com |
//+------------------------------------------------------------------+
#property copyright "Copyright  2006, soso_beton"
#property link      "http://www.fxlogs.com"

// #property indicator_separate_window
#property indicator_chart_window
#property indicator_buffers 5

#property indicator_color2 Red
#property indicator_color3 Lime

extern color color_1 = DarkGoldenrod;
extern color color_2 = BurlyWood;


double      buffer1[];
double      buffer2[];
double      buffer3[];
double      buffer4[];
double      buffer5[];

int         EMA1_Period = 100;
int         EMA2_Period = 144;
int         EMA3_Period = 200;



//+------------------------------------------------------------------+
//| Custom indicator initialization function                         |
//+------------------------------------------------------------------+
int init()
{
   IndicatorShortName("SOS_Channels v1.0");
   
   SetIndexStyle(0, DRAW_LINE, EMPTY, 2, color_2);
   SetIndexBuffer(0, buffer1);
   SetIndexDrawBegin(0, EMA3_Period);
   SetIndexLabel(0, "EMA 100");
   
   SetIndexStyle(1, DRAW_LINE, EMPTY, 2, color_1);
   SetIndexBuffer(1, buffer2);
   SetIndexDrawBegin(1, EMA3_Period);
   SetIndexLabel(1, "EMA 144");

   SetIndexStyle(2, DRAW_LINE, EMPTY, 2, color_2);
   SetIndexBuffer(2, buffer3);
   SetIndexDrawBegin(2, EMA3_Period);
   SetIndexLabel(2, "EMA 200");

   SetIndexStyle(3, DRAW_HISTOGRAM,STYLE_SOLID, 5, color_1);
   SetIndexBuffer(3, buffer4);
   SetIndexDrawBegin(3, EMA3_Period);
   SetIndexLabel(3, NULL);

   SetIndexStyle(4, DRAW_HISTOGRAM, STYLE_SOLID, 5, color_1);
   SetIndexBuffer(4, buffer5);
   SetIndexDrawBegin(4, EMA3_Period);
   SetIndexLabel(4, NULL);

   return(0);
}



//+------------------------------------------------------------------+
//| Custom indicator deinitialization function                       |
//+------------------------------------------------------------------+
int deinit()
{
    return(0);
}



//+------------------------------------------------------------------+
//| Custom indicator iteration function                              |
//+------------------------------------------------------------------+
int start()
{
    int counted_bars = IndicatorCounted();
    if (counted_bars < 0)
    {
        return (-1);
    }
    else if (counted_bars > 0)
    {
        counted_bars--;
    }
    int limit = Bars - counted_bars;
    
    for (int i =0; i < limit; i++)
    {
        buffer1[i] = iMA(NULL, 0, EMA1_Period, 0, MODE_EMA, PRICE_CLOSE, i);
        buffer2[i] = iMA(NULL, 0, EMA2_Period, 0, MODE_EMA, PRICE_CLOSE, i);
        buffer3[i] = iMA(NULL, 0, EMA3_Period, 0, MODE_EMA, PRICE_CLOSE, i);
        
        buffer4[i] = buffer1[i];
        buffer5[i] = buffer3[i];
    }
    
    return(0);
}

